<script lang="ts">
  import { bounceOut } from "svelte/easing";
  import { fly, slide, fade } from "svelte/transition";
  import Card from "./lib/Card.svelte";
  import CardColumn from "./lib/CardColumn.svelte";
  import CardPile from "./lib/CardPile.svelte";
  import CardSlot from "./lib/CardSlot.svelte";
  import Clickable from "./lib/Clickable.svelte";
  import Flag from "./lib/Flag.svelte";

  import Player from "./lib/Player.svelte";
  import {
    createActionDispatcher,
    findWinner,
    isPlayerActive,
    wonBattle,
    zip,
  } from "./utils";
  const dispatchAction = createActionDispatcher();

  export let playerId: PlayerId | null = null;
  export let state: GameState;
  // export let settings: GameSettings;

  $: flipPlayers = state.players[0]?.id === playerId;

  let sortedPlayers: PlayerState[] = [...state.players];
  $: {
    if (flipPlayers) {
      sortedPlayers = [state.players[1], state.players[0]];
    } else {
      sortedPlayers = state.players;
    }
  }

  $: user = state.players.find((p) => p.id === playerId);

  function getPlayerStyle(idx: number): string {
    const translateY = idx === 1 ? "20rem" : "-20rem";
    return `
      --player-translate-y: ${translateY};
    `;
  }

  type Battle = [CardId[], CardId[]];

  let battles: Battle[] = [];
  $: {
    if (sortedPlayers.length === 2) {
      battles = zip(sortedPlayers[0].placed, sortedPlayers[1].placed);
    }
  }

  let mode: Mode | null = null;
  $: {
    if (
      mode?.name === "placing-card" &&
      !user?.hand.includes(mode.selectedCard)
    ) {
      mode = null;
    } else if (
      mode?.name === "claiming-battle" &&
      (!user || !isPlayerActive(state.phase, user.id) || failedClaim)
    ) {
      mode = null;
    }
  }

  let failedClaim: FailedClaim | null;
  $: failedClaim = state.phase[0] !== "ended" ? state.phase[2] : null;

  let userHint: string | null;
  $: {
    userHint = null;
    if (user && isPlayerActive(state.phase, user.id)) {
      if (mode?.name === "claiming-battle") {
        userHint = "Select a location. ↑";
      } else if (state.phase[0] === "placing") {
        userHint =
          mode?.name === "placing-card" ? "Place card. ↑" : "Select a card. ↓";
      } else if (state.phase[0] === "drawing") {
        userHint = "Draw a card. ↗";
      }
    }
  }
</script>

<div class="center">
  <div class="battle-border-line" role="presentation" />
  <div class="relative flex flex-nowrap gap-8 items-center">
    <div class="battles gap-4">
      {#each battles as [cards1, cards2], battleIndex (battleIndex)}
        {@const claimingPlayer = state.claims[battleIndex]}

        <div class="battle gap-3 relative">
          <CardSlot>
            <CardColumn cards={cards1} growUpwards />
          </CardSlot>

          <CardSlot>
            <CardColumn
              cards={cards2}
              clickable={user !== undefined &&
                mode?.name === "placing-card" &&
                cards2.length < 3 &&
                state.claims[battleIndex] == null}
              on:place_card={() => {
                if (mode?.name === "placing-card")
                  dispatchAction(["place", mode.selectedCard, battleIndex]);
              }}
            />
          </CardSlot>

          {#if failedClaim !== null && failedClaim[0] === battleIndex}
            <div class="claim-battle">
              <div class="emoji text-2xl">❌</div>
            </div>
          {:else if claimingPlayer !== null}
            <div class="battle-flag text-3xl">
              <div
                in:fly={{
                  duration: 500,
                  x: 0,
                  y: -50,
                  easing: bounceOut,
                }}
                out:slide={{ duration: 500 }}
              >
                <Flag players={state.players} playerId={claimingPlayer} />
              </div>
              <div class="battle-flag-shadow" />
            </div>
          {:else if user && mode?.name === "claiming-battle" && user.placed[battleIndex]?.length == 3 && wonBattle(state, user.id, battleIndex) !== false}
            <div class="claim-battle">
              <Clickable
                on:click={() => {
                  dispatchAction(["claim", battleIndex]);
                  mode = null;
                }}
              />
            </div>
          {/if}
        </div>
      {/each}
    </div>

    <div class="deck">
      <CardSlot>
        <CardPile
          cards={state.deck}
          facedown
          clickable={user &&
            state.phase[0] === "drawing" &&
            mode === null &&
            isPlayerActive(state.phase, user.id)}
          on:draw_card={() => dispatchAction(["draw"])}
        />
      </CardSlot>
    </div>

    {#if failedClaim !== null}
      <div class="info-msg panel" transition:fade>
        Failed to plant flag!
        {#each failedClaim[1] as card}
          <Card inline {card} />{" "}
        {/each}
        is better.
      </div>
    {:else if state.phase[0] === "ended"}
      <div class="info-msg panel p-4 text-xl" transition:fade>
        <gs6-user playerid={findWinner(state.claims)} /> wins!
      </div>
    {/if}

    {#each [userHint].filter((x) => x) as hint (hint)}
      <div
        class="user-hint-msg"
        in:fly={{ delay: 5000, y: 0, x: 100, duration: 2000 }}
        out:fade
      >
        {hint}
      </div>
    {/each}
  </div>
</div>

{#each state.players as player (player.id)}
  {@const playerIndex = sortedPlayers.findIndex((p) => p.id === player.id)}

  <div class="player" style={getPlayerStyle(playerIndex)}>
    <Player
      {player}
      {state}
      {mode}
      isUser={player.id === playerId}
      on:select_card={(evt) => {
        if (mode?.name === "placing-card" && mode.selectedCard === evt.detail) {
          mode = null;
        } else {
          mode = { name: "placing-card", selectedCard: evt.detail };
        }
      }}
      on:claim_click={() => {
        mode = { name: "claiming-battle" };
      }}
      on:cancel_click={() => {
        mode = null;
      }}
      on:skip_click={() => {
        dispatchAction(["skip"]);
      }}
    />
  </div>
{/each}

<style>
  .center {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .battles {
    display: grid;
    grid-template-columns: repeat(9, auto);
  }

  .info-msg {
    position: absolute;
    top: -1rem;
    left: 50%;
    transform: translate(-50%, -100%);
  }
  .user-hint-msg {
    position: absolute;
    bottom: -4.5rem;
    left: 50%;
    transform: translate(-50%, 100%);

    font-size: 90%;
    font-style: oblique;
    font-weight: 300;
  }

  .battle-border-line {
    position: absolute;
    margin: 0;
    width: 100%;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%) translateX(-2.5em);
    border-top: 0.25rem dashed #0003;
  }

  .battle {
    display: grid;
    grid-template-rows: auto auto;
  }

  .battle-flag {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(-50%);
  }

  .battle-flag-shadow {
    position: relative;
  }
  .battle-flag-shadow::after {
    content: "";
    position: absolute;
    width: 100%;
    height: 2px;
    /* filter: drop-shadow(0 0 1px black); */
    border-radius: 100%;
    background-color: #0003;

    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
  }

  .claim-battle {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .player {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(var(--player-translate-y));
    transition: transform 0.5s;
  }
</style>
